# Create link

`POST /v1/operations/translationsetlinks`

Available as MCP tool `create-translation-set-link` (Write).

Translation set endpoints allow you to review and manage value sets, translation sets, and related translation set links. 

A <u>value set</u> is a list of values (e.g., LOINC, SNOMED, or a custom code set) that should be translated during the process of data exchange. [Learn about value sets](https://docs.redoxengine.com/permalink/57h6bja3T7Qy0Mf1ai7uMQ).

A <u>translation set</u> contains two value sets: one for incoming values and one for outgoing values between systems. A translation set also defines how those values should map to each other. [Learn about translation sets](https://docs.redoxengine.com/permalink/4GJXunyoAI3s05VrrRkJ09). 

A <u>translation set link</u> defines where the translation set should be applied in log processing for a specific subscription.

Anyone in a Redox organization can view translation sets and related value sets or links, but you must be assigned to an engineer or support role to update or delete them.

You can:

- retrieve a list of value sets by environment or organization;
- retrieve a list of translation sets by environment or organization;
- create, update, or delete value sets;
- create, update, or delete translation sets or links;
- create, update, or delete a value in a value set; or
- create or delete a translation in a translation set;

### Create link

Apply a translation set to a specific location within log processing. There are up to four stages that you can link a translation set to (i.e., `REQUEST` and `RESPOND` or `SEND` and `RECEIVE`), depending on whether you own either the source, destination, or both. [Learn about log processing stages](https://docs.redoxengine.com/permalink/790exE7anSFdJdupyjnidt/#processing-stages-and-operations). 

To fully link a translation set, you must select the relevant field path where the translation should happen. 

You can create a value set via API or the Redox dashboard ([create and link a translation set in the dashboard](https://docs.redoxengine.com/permalink/4GJXunyoAI3s05VrrRkJ09)).

This endpoint allows you to link one translation set at a time. 

> **Only for engineer or support roles**
>
> Any user may view existing data operations (e.g., filters, translation sets, config modifiers) for subscriptions in a given environment. However, you must be assigned to an engineer or a support role to create and manage data operations. [Learn about roles](/basics/managing-access-for-your-redox-organization/what-are-user-roles-and-groups).

## Request body

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `translationSet` | object | Yes | Describes the translation set being linked. |
| `translationSet.id` | string (uuid) | No | Contains the unique identifier of the asset. |
| `source` | object | Yes | Specifies the source of the subscription that an asset is or should be linked to. |
| `source.id` | string (uuid) | Yes | Contains the unique identifier of the source. |
| `destination` | object | Yes | Specifies the destination of the subscription that an asset is or should be linked to. |
| `destination.id` | string (uuid) | Yes | Contains the unique identifier of the destination. |
| `dataModel` | string | Yes | Specifies the Redox data model that the link applies to or should apply to. |
| `direction` | string | Yes | Indicates the direction in which the translation set is or should be linked. This can be either `from-to` (translates a "from" value into a "to" value), or `to-from` (tranlates a "to" value into a "from" value). Possible values: from-to, to-from |
| `processingLocation` | string | Yes | Identifies where a link will be applied during log processing. There are up to four stages that an asset can be linked to, depending on whether you own either the source, the destination, or both. Possible values: source-request, destination-request, source-response, destination-response |
| `paths` | Array of object | Yes | Lists the field paths linked to a translation set. These paths must be unique on the path property. |
| `paths[].dataType` | string | No | Describes the format of the data found at the path location. |
| `paths[].title` | string | No | Specifies a human-readable title for the field path. |
| `paths[].path` | string | No | Specifies the path in a message to the location of the data to be translated. The path must always start with a $ to be considered valid. |

## Request example

_Generated from the schema: the values are placeholders, not a real payload._

```bash
curl 'https://api.redoxengine.com/platform/v1/operations/translationsetlinks' \
--request POST \
--header 'Authorization: Bearer $API_TOKEN' \
--header 'accept: application/json' \
--header 'Content-Type: application/json' \
--data '{
  "translationSet": {
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  },
  "source": {
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  },
  "destination": {
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  },
  "dataModel": "PatientAdmin",
  "direction": "to-from",
  "processingLocation": "source-request",
  "paths": [
    {
      "dataType": "string",
      "title": "Custom Path",
      "path": "$.Allergies[*].Type.Code"
    }
  ]
}'
```

## Responses

### 200

Contains a payload object with the id of the created or modified asset.

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `meta` | object | No |  |
| `meta.version` | string | No | Lists the major and minor version number for the format of the returned payload. The payload format or shape may change between minor versions, like including additional or extended fields in later versions. We include the version data in each response so that you have the option to handle the signaled differences. |
| `payload` | object | No | Contains the id of the created or modified asset. |
| `payload.id` | string (uuid) | No | Contains the unique identifier of the asset. |

_Generated from the schema: the values are placeholders, not a real payload._

```json
{
  "meta": {
    "version": "1.0.0"
  },
  "payload": {
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  }
}
```

### 400

Bad Request

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.error` | object | No | Contains the error message details. |
| `payload.error.id` | string | No | Contains a unique identifier for the given error instance. |
| `payload.error.title` | string | No | Displays the high-level error message, typically something succinct like `Bad Request`. |
| `payload.error.code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |
| `payload.error.detail` | string | No | Contains the specific error details for this message. |
| `payload.error.status` | number | No | Displays the corresponding HTTP status code for the error. |
| `payload.error.transient` | boolean | No | Describes whether the error will resolve itself. If `true`, no further action needs to be taken. If `false`, you may need to troubleshoot on your end to resolve the issue before the error can be processed. |

```json
{
  "payload": {
    "error": {
      "title": "Bad Request",
      "code": "validation.error.bad.request",
      "detail": "Error details",
      "status": 400,
      "transient": false
    }
  }
}
```

### 403

Forbidden

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.errors` | Array of object | No |  |
| `payload.errors[].title` | string | No | Displays the high-level error message, typically something succinct like `Forbidden`. |
| `payload.errors[].code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |

```json
{
  "payload": {
    "errors": [
      {
        "title": "Forbidden",
        "code": "authorization.forbidden"
      }
    ]
  }
}
```

### 500

Internal Server Error

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.error` | object | No | Contains the error message details. |
| `payload.error.title` | string | No | Displays the high-level error message, typically something succinct like `Failed in step X`. |
| `payload.error.code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |
| `payload.error.detail` | string | No | Contains the specific error details for this message. |
| `payload.error.status` | number | No | Displays the corresponding HTTP status code for the error. |
| `payload.error.transient` | boolean | No | Describes whether the error will resolve itself. If `true`, no further action needs to be taken. If `false`, you may need to troubleshoot on your end to resolve the issue before the error can be processed. |

```json
{
  "payload": {
    "error": {
      "title": "Internal Server Error",
      "code": "failed.db.lookup",
      "detail": "Error details",
      "status": 500,
      "transient": true
    }
  }
}
```
